<i18n>
{
  "fr": {
    "title": "Configuration avancée",
    "position": "Statut",
    "purpose": "Motif",
    "mode": "Mode de déplacement",
    "replace.plane": "Remplacer l'avion",
    "replace.plane.l1help": "Distance à partir de laquelle remplacer l'avion par le train.",
    "replace.plane.l2help": "Selectionner un statut et/ou un motif sur lequel filtrer l'application de la variable.",
    "limit.plane": "Limiter l'avion",
    "limit.plane.l1help": "Distance en avion à partir de laquelle la mission est annulée.",
    "limit.plane.l2help": "Selectionner un statut et/ou un motif sur lequel filtrer l'application de la variable.",
    "replace.plane.national": "Remplacer l'avion en France",
    "replace.plane.national.label": "Avion / train",
    "replace.plane.national.l1help": "Remplacer tous les déplacements de France métropolitaine réalisés en avion par le train.",
    "annual.collective.quota": "Quota collectif annuel",
    "annual.collective.quota.l1help": "Limiter la distance annuelle collective parcourue en avion.",
    "annual.collective.quota.l2help": "Selectionner un statut et/ou un motif sur lequel filtrer l'application de la variable.",
    "carpooling": "Favoriser le covoiturage",
    "carpooling.l1help": "Nombre de covoitureurs par déplacement en voiture.",
    "teleworking": "Développer le télétravail",
    "teleworking.l1help": "Nombre de jours télétravaillés par personne et par semaine.",
    "replace.car": "Remplacer la voiture",
    "replace.car.l1help": "Remplacer un % de km parcourus en voiture par un mode de transport alternatif.",
    "replace.car.l2help": "Selectionner un mode de déplacement alternatif à la voiture.",
    "car.electrification": "Électrification des voitures",
    "car.electrification.l1help": "Électrifier un % de voitures utilisées pour les déplacements domicile / travail"
  },
  "en": {
    "title": "Advanced settings",
    "position": "Position",
    "purpose": "Purpose",
    "mode": "Mode of transportation",
    "replace.plane": "Replace plane",
    "replace.plane.l1help": "Distance from which to replace the plane by the train.",
    "replace.plane.l2help": "Select a position and/or a purpose on which to filter the application of the variable.",
    "limit.plane": "Limit plane",
    "limit.plane.l1help": "Distance by plane from which the travel is cancelled.",
    "limit.plane.l2help": "Select a position and/or a purpose on which to filter the application of the variable.",
    "replace.plane.national": "Replace plane in France",
    "replace.plane.national.label": "Plane / train",
    "replace.plane.national.l1help": "Replace all travels in France made by plane with the train.",
    "annual.collective.quota": "Annual collective quota",
    "annual.collective.quota.l1help": "Limit the collective annual distance traveled by plane.",
    "annual.collective.quota.l2help": "Select a position and/or a purpose on which to filter the application of the variable.",
    "carpooling": "Encourage carpooling",
    "carpooling.l1help": "Number of carpoolers per car trip.",
    "teleworking": "Develop teleworking",
    "teleworking.l1help": "Number of days teleworked per person per week.",
    "replace.car": "Replace car",
    "replace.car.l1help": "Replace a % of km driven by car with an alternative mode of transportation.",
    "replace.car.l2help": "Select an alternative mode of transportation to the car.",
    "car.electrification": "Cars electrification",
    "car.electrification.l1help": "Electrify a % of cars used for commuting"
  }
}
</i18n>

<template>
  <div>
    <b-field>
      <template slot="label">
        <nav class="level">
          <div class="level-left">
            {{ $t(data.name) }}
          </div>
          <div
            v-if="Object.keys(data).includes('level2')"
            class="level-right"
          >
            <b-icon
              icon="cog"
              type="is-info"
              @click.native="configModal=true"
              :class="'is-' + data.module"
            />
          </div>
        </nav>
        <p class="sub-label"> {{ $t(data.name + '.l1help') }} </p>
      </template>
      <b-slider
        v-if="data.level1.type==='slider'"
        v-model="data.level1.value"
        :min="data.level1.min"
        :max="data.level1.max"
        :step="data.level1.step"
        :custom-formatter="(val) => val + ' ' + data.level1.unit"
        @input="$emit('input')"
        :class="'is-' + data.module"
      >
        <b-slider-tick :value="data.level1.min">
          {{ data.level1.min }}{{ data.level1.unit }}
        </b-slider-tick>
        <b-slider-tick :value="data.level1.max">
          {{ data.level1.max }}{{ data.level1.unit }}
        </b-slider-tick>
      </b-slider>
      <b-switch
        v-if="data.level1.type==='switch'"
        v-model="data.level1.value"
        @input="$emit('input')"
        size="is-small"
        :class="'is-' + data.module"
      >
        {{ $t(data.name + '.label') }}
      </b-switch>
    </b-field>
    <b-modal
      v-if="Object.keys(data).includes('level2')"
      :active.sync="configModal"
      has-modal-card
    >
      <div class="modal-card">
        <header class="modal-card-head">
          <p class="modal-card-title">
            {{ $t('title') }}
          </p>
        </header>
        <section class="modal-card-body">
          <b-notification :closable="false">
            {{ $t(data.name + '.l2help') }}
          </b-notification>
          <b-field
            v-for="(param,index) in Object.keys(data.level2)"
            :key="index"
            :label="$t(param)"
          >
            <b-select
              v-if="data.level2[param].type==='select'"
              :placeholder="$t(param)"
              v-model="values[param]"
              expanded
            >
              <option
                v-for="(value,index) in data.level2[param].values"
                :key="index"
                :value="value"
              >
                {{ $t(value) }}
              </option>
            </b-select>
          </b-field>
          <hr>
          <nav class="level">
            <div class="level-left"></div>
            <div class="buttons level-right">
              <b-button
                class="button"
                @click="resetValues"
                icon-left="close"
              >
                {{ $t('clear') }}
              </b-button>
              <b-button
                class="button"
                @click="updateLevel2"
                icon-left="cog"
                type="is-primary"
              >
                {{ $t('apply') }}
              </b-button>
            </div>
          </nav>
        </section>
      </div>
    </b-modal>
  </div>
</template>

<script>
export default {
  name: 'Variable',
  props: {
    data: {
      type: Object,
      default: null
    }
  },
  data () {
    return {
      configModal: false,
      values: {}
    }
  },
  methods: {
    resetValues () {
      this.values = {}
      this.configModal = false
      this.$emit('reset-level2', {
        name: this.data.name
      })
    },
    updateLevel2 () {
      this.$emit('update-level2', {
        name: this.data.name,
        values: this.values
      })
      this.configModal = false
    }
  }
}
</script>

<style scoped>
.sub-label {
  font-size: .7rem;
  font-weight: 400;
}
nav.level {
  margin-bottom: 0;
}
span.icon {
  cursor: pointer;
}
</style>

<style>
.b-slider.is-heating .b-slider-fill {
  background: #c84896 !important;
}
.has-text-info.is-heating {
  color: #c84896 !important;
}
.b-slider.is-heating .b-tooltip.is-primary .tooltip-content {
  background: #c84896;
}
.b-slider.is-heating .b-tooltip.is-top.is-primary .tooltip-content::before {
  border-top-color: #c84896 !important;
}
.switch.is-heating input[type="checkbox"]:checked + .check {
  background: #c84896 !important;
}
.switch.is-heating input[type="checkbox"]:focus:checked + .check {
  -webkit-box-shadow: 0 0 .5em rgba(200, 72, 150, 0.8) !important;
  box-shadow: 0 0 .5em rgba(200, 72, 150,.8) !important;
}

.b-slider.is-electricity .b-slider-fill {
  background: #e88bc3 !important;
}
.has-text-info.is-electricity {
  color: #e88bc3 !important;
}
.b-slider.is-electricity .b-tooltip.is-primary .tooltip-content {
  background: #e88bc3;
}
.b-slider.is-electricity .b-tooltip.is-top.is-primary .tooltip-content::before {
  border-top-color: #e88bc3 !important;
}
.switch.is-electricity input[type="checkbox"]:checked + .check {
  background: #e88bc3 !important;
}
.switch.is-electricity input[type="checkbox"]:focus:checked + .check {
  -webkit-box-shadow: 0 0 .5em rgba(232, 139, 195, 0.8) !important;
  box-shadow: 0 0 .5em rgba(232, 139, 195,.8) !important;
}

.b-slider.is-refrigerants .b-slider-fill {
  background: #fdc2e5 !important;
}
.has-text-info.is-refrigerants {
  color: #fdc2e5 !important;
}
.b-slider.is-refrigerants .b-tooltip.is-primary .tooltip-content {
  background: #fdc2e5;
}
.b-slider.is-refrigerants .b-tooltip.is-top.is-primary .tooltip-content::before {
  border-top-color: #fdc2e5 !important;
}
.switch.is-refrigerants input[type="checkbox"]:checked + .check {
  background: #fdc2e5 !important;
}
.switch.is-refrigerants input[type="checkbox"]:focus:checked + .check {
  -webkit-box-shadow: 0 0 .5em rgba(253, 194, 229, 0.8) !important;
  box-shadow: 0 0 .5em rgba(253, 194, 229,.8) !important;
}

.b-slider.is-vehicles .b-slider-fill {
  background: #fd8e62 !important;
}
.has-text-info.is-vehicles {
  color: #fd8e62 !important;
}
.b-slider.is-vehicles .b-tooltip.is-primary .tooltip-content {
  background: #fd8e62;
}
.b-slider.is-vehicles .b-tooltip.is-top.is-primary .tooltip-content::before {
  border-top-color: #fd8e62 !important;
}
.switch.is-vehicles input[type="checkbox"]:checked + .check {
  background: #fd8e62 !important;
}
.switch.is-vehicles input[type="checkbox"]:focus:checked + .check {
  -webkit-box-shadow: 0 0 .5em rgba(253, 142, 98, 0.8) !important;
  box-shadow: 0 0 .5em rgba(253, 142, 98,.8) !important;
}

.b-slider.is-travels .b-slider-fill {
  background: #67c3a5 !important;
}
.has-text-info.is-travels {
  color: #67c3a5 !important;
}
.b-slider.is-travels .b-tooltip.is-primary .tooltip-content {
  background: #67c3a5;
}
.b-slider.is-travels .b-tooltip.is-top.is-primary .tooltip-content::before {
  border-top-color: #67c3a5 !important;
}
.switch.is-travels input[type="checkbox"]:checked + .check {
  background: #67c3a5 !important;
}
.switch.is-travels input[type="checkbox"]:focus:checked + .check {
  -webkit-box-shadow: 0 0 .5em rgba(90, 171, 144, 0.8) !important;
  box-shadow: 0 0 .5em rgba(90, 171, 144,.8) !important;
}

.b-slider.is-commutes .b-slider-fill {
  background: #8ea0cc !important;
}
.has-text-info.is-commutes {
  color: #8ea0cc !important;
}
.b-slider.is-commutes .b-tooltip.is-primary .tooltip-content {
  background: #8ea0cc;
}
.b-slider.is-commutes .b-tooltip.is-top.is-primary .tooltip-content::before {
  border-top-color: #8ea0cc !important;
}
.switch.is-commutes input[type="checkbox"]:checked + .check {
  background: #8ea0cc !important;
}
.switch.is-commutes input[type="checkbox"]:focus:checked + .check {
  -webkit-box-shadow: 0 0 .5em rgba(142, 160, 204, 0.8) !important;
  box-shadow: 0 0 .5em rgba(142, 160, 204,.8) !important;
}

.b-slider.is-computerdevices .b-slider-fill {
  background: #a6d953 !important;
}
.has-text-info.is-computerdevices {
  color: #a6d953 !important;
}
.b-slider.is-computerdevices .b-tooltip.is-primary .tooltip-content {
  background: #a6d953;
}
.b-slider.is-computerdevices .b-tooltip.is-top.is-primary .tooltip-content::before {
  border-top-color: #a6d953 !important;
}
.switch.is-computerdevices input[type="checkbox"]:checked + .check {
  background: #a6d953 !important;
}
.switch.is-computerdevices input[type="checkbox"]:focus:checked + .check {
  -webkit-box-shadow: 0 0 .5em rgba(166, 217, 83, 0.8) !important;
  box-shadow: 0 0 .5em rgba(166, 217, 83,.8) !important;
}

.b-slider.is-purchases .b-slider-fill {
  background: #ffda2c !important;
}
.has-text-info.is-purchases {
  color: #ffda2c !important;
}
.b-slider.is-purchases .b-tooltip.is-primary .tooltip-content {
  background: #ffda2c;
}
.b-slider.is-purchases .b-tooltip.is-top.is-primary .tooltip-content::before {
  border-top-color: #ffda2c !important;
}
.switch.is-purchases input[type="checkbox"]:checked + .check {
  background: #ffda2c !important;
}
.switch.is-purchases input[type="checkbox"]:focus:checked + .check {
  -webkit-box-shadow: 0 0 .5em rgba(255, 218, 44, 0.8) !important;
  box-shadow: 0 0 .5em rgba(255, 218, 44,.8) !important;
}
</style>
